%% Data Z podložky WBB
clear all 
clc
close all
%% načtení naměřených dat
[FileName,PathName] = uigetfile('*.xlsx'); %vyskočí okno průzkumníku souborů, kde je třeba vybrat ve složce 'namerena data WBB' data pro daného probanda
data=importdata(fullfile(PathName,FileName));
[FileName2,PathName2] = uigetfile('*.xlsx'); %vyskočí okno průzkumníku souborů, kde je třeba vybrat ve složce 'pmocné tabulky WBB' data pro daného probanda
data2=importdata(fullfile(PathName2,FileName2));
%% Tato data je možné měnit
filename03='03_WBB_tabulka.xlsx'; %jméno složky, kam se budou ukládat výsledky
proband=3;
%%
file=data.data;
file02=data2.data;
anterior_01=file(:,2);
dexter_01=file(:,7);
for k=1:28;% výběr čísla měření

a=file02(k,7); %počátek signálu
b=file02(k,8); %konec signálu
rozsah=a:b;
%% mazání okrajových hodnot
a2=a+file02(k,9); %počtek signálu posunutý o okrajovou hodnoty
b2=b-file02(k,10); %konec signálu - odečtená okrajová hodnota
rozsah2=a2:b2;
Xsur=dexter_01(rozsah2); %surový signál - výchylka COP v bočním směru
Ysur=anterior_01(rozsah2); %surový signál - výchylka COP v předozadním směru
%% Provedení převzorkování - lineární interpolace
c=b2-a2+1; %počet vzorků ve vybraném intervalu
time=19; %délka měření v sekundách - po smazání okrajových hodnot vždy 19
pfvz=90; %požadovaná vzorkovací frekvence
pocet_vzorku=pfvz*time; %požadovaný počet vzorků po interpolaci = 1710 vzorků
YI=interp1(rozsah2,Xsur,linspace(a2,b2,pocet_vzorku),'linear');
YII=interp1(rozsah2,Ysur,linspace(a2,b2,pocet_vzorku),'linear');
%% filtrace Butter. filter 
YI=YI-YI(1); 
YII=YII-YII(1);
fvz=length(YI)/19;
[b,a]=butter(4,12/(pfvz/2),'low'); %filtr typu dolní propust, mezní frekvence 12 Hz
filterYI=filter(b,a,YI);
filterYII=filter(b,a,YII);
%% odečtení střední hodnotu -> střed statokinezigramu v [0,0]
filterYI=filterYI-mean(filterYI);
filterYII=filterYII-mean(filterYII);
%% provedení výpočtů parametrů
[Ax,Ay,delka_pohybu_COP,TA,stredni_polomer,RMS]=vypocet(filterYI,filterYII);
[obsah_95elipsa]=error_ellipse(filterYI,filterYII);
vysledna_tabulka(k,1:7)=[Ax,Ay,delka_pohybu_COP,TA,stredni_polomer,RMS,obsah_95elipsa];
end
 proband1=[4,23,28];
 proband2=[28];
 proband3=[12,13,14,26,27,28];
 proband4=[3,4,5,6,7,8,13,22];
 proband5=[20,16];
 proband6=[4,9,19];
 proband7=[1,2,5,6,8];
 proband8=[5,22];
 proband9=[5,6,9,10,13,14,21];
 proband10=[1,5,6,8,13];
 del={proband1,proband2,proband3,proband4,proband5,proband6,proband7,proband8,proband9,proband10};

vysledna_tabulka_puv=vysledna_tabulka;
vysledna_tabulka(del{proband},:)=NaN; %odstranění špatně naměřených hodnot
%% vykreslení tabulky do excelu
 pole = cell(15,8);
 pole{2,1} = 'otevřené oči';
 pole{3,1} = 'otevřené oči';
 pole{4,1} = 'otevřené oči - fixace';
 pole{5,1} = 'otevřené oči - fixace';
 pole{6,1} = 'zavřené oči';
 pole{7,1} = 'zavřené oči';
 pole{8,1} = 'bod vysoko';
 pole{9,1} = 'bod vysoko';
 pole{10,1} = 'bod na zemi';
 pole{11,1} = 'bod na zemi';
 pole{12,1} = 'pohyb svisle';
 pole{13,1} = 'pohyb svisle';
 pole{14,1} = 'pohyb vodorovně';
 pole{15,1} = 'pohyb vodorovně';
 pole{16,1} = 'pohyb vodorovně + svisle';
 pole{17,1} = 'pohyb vodorovně + svisle';
 pole{18,1} = 'kruhový pohyb';
 pole{19,1} = 'kruhový pohyb';
 pole{20,1} = 'zmenšování + zvětšování bodu';
 pole{21,1} = 'zmenšování + zvětšování bodu';
 pole{22,1} = 'video - vzdalování bodu';
 pole{23,1} = 'video - vzdalování bodu';
 pole{24,1} = 'text jednoduchý';
 pole{25,1} = 'text jednoduchý';
 pole{26,1} = 'text anglicky';
 pole{27,1} = 'text anglicky';
 pole{28,1} = 'text - zhoršená čitelnost';
 pole{29,1} = 'text - zhoršená čitelnost';
 
 pole{1,2} = 'Amplituda horizontalni k.';
 pole{1,3} = 'Amplituda vertikalní k.';
 pole{1,4} = 'Délka signálu EOG';
 pole{1,5} = 'Celková plocha';
 pole{1,6} = 'Střední poloměr';
 pole{1,7} = 'RMS';
 pole{1,8} = 'Obsah 95% elipsy';
 
  xlswrite(filename03,pole,1,'A1'); 
  xlswrite(filename03,vysledna_tabulka,1,'B2');
%% zápis hodnot do tabulky vysledky WBB_druh mereni.xlsx
%filename_vysl='vysledky WBB_druh mereni.xlsx';
% pole2{1,2} = '01_EOG';
%  pole2{1,4} = '02_EOG';
%  pole2{1,6} = '03_EOG';
%  pole2{1,8} = '04_EOG';
%  pole2{1,10} = '05_EOG';
%  pole2{1,12} = '06_EOG';
%  pole2{1,14} = '07_EOG';
%  pole2{1,16} = '08_EOG';
%  pole2{1,18} = '09_EOG';
%  pole2{1,20} = '10_EOG';
%  pole2{1,21} = ' ';
%  
%  pole3{2,1} = 'Amplituda X';
%  pole3{3,1} = 'Amplituda Y';
%  pole3{4,1} = 'Délka křivky';
%  pole3{5,1} = 'Celková plocha';
%  pole3{6,1} = 'Střední poloměr';
%  pole3{7,1} = 'RMS';
%  pole3{8,1} = 'Obsah 95% elipsy';
%  
%  xlRange={'B2','D2','F2','H2','J2','L2','N2','P2','R2','T2'};
%   for h=1:14
%    xlswrite(filename_vysl,pole2,h,'A1'); 
%    xlswrite(filename_vysl,pole3,h,'A1'); 
%    dopln=(vysledna_tabulka(2*h-1:2*h,:))'; 
%    xlswrite(filename_vysl,dopln,h,xlRange{proband});       
%  end
